; NOMAKEIT NOLINK CLEAN
; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
; 

include sqlitevb.inc

; 
    .code
; 

; 

.data?
    dwCurrentDB     DWORD   ?
.const
        DWORD   12      ; length in the DWORD before for BSTR compatibility
    sINSERTINTO BYTE    "INSERT INTO ", 0
        DWORD   8
    sVALUES     BYTE    "VALUES (", 0
    
        DWORD   7
    sUPDATE     BYTE    "UPDATE ", 0
        DWORD   5
    sSET        BYTE    " SET ", 0
        DWORD   7
    sWHERE      BYTE    " WHERE ", 0
    
        DWORD   12
    sDELETE     BYTE    "DELETE FROM ", 0
    
    spInsertInto    TEXTEQU <OFFSET sINSERTINTO>
    spValues        TEXTEQU <OFFSET sVALUES>
    spUpdate        TEXTEQU <OFFSET sUPDATE>
    spSet           TEXTEQU <OFFSET sSET>
    spDelete        TEXTEQU <OFFSET sDELETE>
    spWhere         TEXTEQU <OFFSET sWHERE>
    
    
    sBEGIN      BYTE    "BEGIN EXCLUSIVE", 0
    sCOMMIT     BYTE    "COMMIT", 0
    sROLLBACK   BYTE    "ROLLBACK", 0
.code

Begin PROC USES esi lDB:DWORD
    mov     esi, 10
    mov     eax, lDB
    mov     dwCurrentDB, eax
@Retry:
    invoke  sqlite3_exec, dwCurrentDB, OFFSET sBEGIN, 0, 0, 0
    .if(eax == SQLITE_BUSY)
        invoke  Sleep, 500
        dec esi
        jnz @Retry
    .endif
    .if(eax)
        or  eax, HRESULT_SQLITE
    .endif
    ret
Begin ENDP

; -------------------------------------------------------------------------

Commit PROC USES esi
    mov     esi, 10
    .if(dwCurrentDB != -1)
      @Retry:
        invoke  sqlite3_exec, dwCurrentDB, OFFSET sCOMMIT, 0, 0, 0
        .if(eax == SQLITE_BUSY)
            invoke  Sleep, 500
            dec     esi
            jnz     @Retry
        .elseif(eax)
            or  eax, HRESULT_SQLITE
        .endif
    .else
        mov     eax, HRESULT_NO_BEGIN
    .endif
    mov     dwCurrentDB, -1
    ret
Commit ENDP

; -------------------------------------------------------------------------

Rollback PROC
    mov     eax, dwCurrentDB
    mov     dwCurrentDB, -1
    .if(eax != -1)
        invoke  sqlite3_exec, eax, OFFSET sROLLBACK, 0, 0, 0
        .if(eax)
            or  eax, HRESULT_SQLITE
        .endif
    .else
        mov     eax, HRESULT_NO_BEGIN
    .endif
    ret
Rollback ENDP

; 

InsertInto PROC USES esi edi spTable:DWORD, spColumns:DWORD, saValues:DWORD
    LOCAL   sStatement[512]:BYTE
    
    mov     eax, dwCurrentDB
    cmp     eax, -1
    je      Abort
    
    
    mov     esi, spInsertInto
    lea     edi, sStatement
    mov     ecx, [esi-4]
    cld
    repmovsbw
        ; sStatement = "INSERT INTO "
    
    mov     esi, spTable
    mov     ecx, [esi-4]
    repmovsb
    mov     WORD PTR [edi+0], ' '
    mov     WORD PTR [edi+2], '('
    add     edi, 4
        ; sStatement = "INSERT INTO <table> ("
    
    mov     esi, spColumns
    mov     ecx, [esi-4]
    repmovsb
    mov     WORD PTR [edi+0], ')'
    mov     WORD PTR [edi+2], ' '
    add     edi, 4
        ; sStatement = "INSERT INTO <table> (<columns>) "
    
    mov     esi, spValues
    mov     ecx, [esi-4]
    repmovsbw
        ; sStatement = "INSERT INTO <table> (<columns>) VALUES ("
    
    mov     esi, spColumns
    .while(WORD PTR [esi])
        .if(BYTE PTR [esi] == ',')
            mov DWORD PTR [edi], (',' SHL 16) OR '?'        ; '?',0,',',0
            add edi, 4
        .endif
        add esi, 2
    .endw
    mov     DWORD PTR [edi], (')' SHL 16) OR '?'            ; '?',0,')',0
    mov     DWORD PTR [edi+4], 0
    
        ; sStatement = "INSERT INTO <table> (<columns>) VALUES (?,?,?)"
    
    InternalPrepareStatement dwCurrentDB, ADDR sStatement
    .if(eax)
        mov     esi, eax
        invoke  SetParameters, esi, saValues
        push    eax
        .if(!eax)
            invoke  ExecuteStep, esi
            mov     [esp], eax
        .endif
        invoke  CloseStatement, esi
        pop     eax
    .else
        mov     eax, ecx
    .endif
    
    or      eax, eax
    jz      @Ret
    or      eax, HRESULT_SQLITE
    jmp     @Ret
Abort:
    mov eax, HRESULT_NO_BEGIN
@Ret:
    ret
InsertInto ENDP

; 

Update PROC USES esi edi ebx spTable:DWORD, spWhereClause:DWORD, spColumns:DWORD, saValues:DWORD
    LOCAL   sStatement[512]:BYTE
    
    mov     eax, dwCurrentDB
    cmp     eax, -1
    je      Abort
    
    
    mov     esi, spUpdate
    lea     edi, sStatement
    mov     ecx, [esi-4]
    cld
    repmovsbw
        ; sStatement = "UPDATE "
    
    mov     esi, spTable
    mov     ecx, [esi-4]
    repmovsb
        ; sStatement = "UPDATE <table>"
    
    mov     esi, spSet
    mov     ecx, [esi-4]
    repmovsbw
        ; sStatement = "UPDATE <table> SET "
    
    mov     esi, spColumns
    .while(WORD PTR [esi])
        mov ax, [esi]
        .if(ax == ',')
            mov DWORD PTR [edi], ('?' SHL 16) OR '='    ; '=',0,'?',0
            add edi, 4
        .endif
        mov [edi], ax
        add esi, 2
        add edi, 2
    .endw
    mov DWORD PTR [edi], ('?' SHL 16) OR '='            ; '=',0,'?',0
    add edi, 4
        ; sStatement = "UPDATE <table> SET <col>=?,<col>=?,<col>=?,<col>=?"
    
    mov     esi, spWhereClause
    .if(esi && WORD PTR [esi])
        mov     esi, spWhere
        mov     ecx, [esi-4]
        repmovsbw
            ; sStatement = "UPDATE <table> SET <col>=?,<col>=?,<col>=?,<col>=? WHERE "
        
        mov     esi, spWhereClause
        mov     ecx, [esi-4]
        repmovsb
            ; sStatement = "UPDATE <table> SET <col>=?,<col>=?,<col>=?,<col>=? WHERE <clause>"
    .endif
    mov     DWORD PTR [edi], 0
    
    InternalPrepareStatement dwCurrentDB, ADDR sStatement
    .if(eax)
        mov     esi, eax
        invoke  SetParameters, esi, saValues
        push    eax
        .if(!eax)
            invoke  ExecuteStep, esi
            mov     [esp], eax
        .endif
        invoke  CloseStatement, esi
        pop     eax
    .else
        mov     eax, ecx
    .endif
    
    or      eax, eax
    jz      @Ret
    or      eax, HRESULT_SQLITE
    jmp     @Ret
Abort:
    mov eax, HRESULT_NO_BEGIN
@Ret:
    ret
Update ENDP

; 

Delete PROC USES esi edi ebx spTable:DWORD, spWhereClause:DWORD
    LOCAL   sStatement[512]:BYTE
    
    mov     eax, dwCurrentDB
    cmp     eax, -1
    je      Abort
    
    
    mov     esi, spDelete
    lea     edi, sStatement
    mov     ecx, [esi-4]
    cld
    repmovsbw
        ; sStatement = "DELETE FROM "
    
    mov     esi, spTable
    mov     ecx, [esi-4]
    repmovsb
        ; sStatement = "DELETE FROM <table>"
    
    mov     esi, spWhereClause
    .if(esi && WORD PTR [esi])
        mov     esi, spWhere
        mov     ecx, [esi-4]
        repmovsbw
            ; sStatement = "DELETE FROM <table> WHERE "
        
        mov     esi, spWhereClause
        mov     ecx, [esi-4]
        repmovsb
            ; sStatement = "DELETE FROM <table> WHERE <clause>"
    .endif
    mov     DWORD PTR [edi], 0
    
    InternalPrepareStatement dwCurrentDB, ADDR sStatement
    .if(eax)
        mov     esi, eax
        invoke  ExecuteStep, esi
        push    eax
        invoke  CloseStatement, esi
        pop     eax
    .else
        mov     eax, ecx
    .endif

    or      eax, eax
    jz      @Ret
    or      eax, HRESULT_SQLITE
    jmp     @Ret
Abort:
    mov eax, HRESULT_NO_BEGIN
@Ret:
    ret
Delete ENDP

; 

Execute PROC USES esi sStatement:DWORD
    mov     eax, dwCurrentDB
    .if(eax != -1)
        ;invoke  sqlite3_exec, dwCurrentDB, sStatement, 0, 0, 0
        push    0
        mov     eax, esp
        invoke  sqlite3_prepare16, dwCurrentDB, sStatement, -1, eax, 0
        .if(eax)
            add esp, 4
            or  eax, HRESULT_SQLITE
        .else
            pop esi
            invoke  sqlite3_step, esi
            .if(eax && eax != SQLITE_DONE)
                or  eax, HRESULT_SQLITE
            .else
                xor eax, eax
            .endif
            push    eax
            invoke  sqlite3_finalize, esi
            pop     eax
        .endif
    .else
        mov eax, HRESULT_NO_BEGIN
    .endif
    ret
Execute ENDP

; 

END
