; NOMAKEIT NOLINK CLEAN
; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
; 

include sqlitevb.inc

; 
    .code
; 

PrepareStatement PROC lDB:DWORD, sStatement:DWORD, lpStatement:DWORD
    push    0
    mov     eax, esp
    invoke  sqlite3_prepare16, lDB, sStatement, -1, eax, 0
    .if(eax == SYSTEM_ERROR_ACCESS_VIOLATION)
        invoke  sqlite3_prepare16, lDB, sStatement, -1, eax, 0
    .endif
    .if(eax != SQLITE_OK)
        or  eax, HRESULT_SQLITE
        add esp, 4
        jmp @Ret
    .endif
    mov     eax, lpStatement
    pop     DWORD PTR [eax]
    xor     eax, eax
@Ret:
    ret
PrepareStatement ENDP

; 

CloseStatement PROC lStatement:DWORD
    invoke  sqlite3_finalize, lStatement
    .if(eax)
        or  eax, HRESULT_SQLITE
    .endif
    ret
CloseStatement ENDP

; 

SetParameters PROC USES esi edi ebx lStatement:DWORD, saParams:DWORD
    mov     edi, saParams
    or      edi, edi
    jz      @Error
    mov     edi, [edi]
    ASSUME  edi:PTR SAFEARRAY
    
    cmp     [edi].cDims, 1
    jne     Error
    test    [edi].fFeatures, (0900h)    ; array of VARIANTs (800h) or BSTRs (100h)
    jz      Error
    cmp     [edi].rgsabound.cElements, 0
    je      Error
    
    push    0
    invoke  SafeArrayAccessData, edi, esp
    pop     esi
    
    invoke  sqlite3_reset, lStatement
    
    .if([edi].fFeatures & 0100h)        ; array of BSTRs (100h)
        xor     ecx, ecx
        .while(ecx < [edi].rgsabound.cElements)
            inc     ecx
            mov     eax, [esi]
            
            invoke  sqlite3_bind_text16, lStatement, ecx, eax, DWORD PTR [eax-4], SQLITE_TRANSIENT
            .if(eax && eax != SQLITE_RANGE)
                or  eax, HRESULT_SQLITE
                jmp Error
            .endif
            add     esi, [edi].cbElements
        .endw
    .elseif([edi].fFeatures & 0800h)    ; array of VARIANTs (800h)
        xor     ecx, ecx
        .while(ecx < [edi].rgsabound.cElements)
            inc     ecx
            push    ecx
            push    esi
            
            mov     eax, [esi]
            .if((al == VT_VARIANT) && (eax & VT_BYREF))
                mov esi, [esi+8]
                mov eax, [esi]
            .endif
            
            .if(eax & VT_BYREF)
                or  ah, -1
            .else
                xor ah, ah
            .endif
            
            push    ecx
            push    eax
            invoke  sqlite3_bind_null, lStatement, ecx
            pop     eax
            pop     ecx
            
            .if(al == VT_I1 || al == VT_UI1 || al == VT_I2 || al == VT_UI2 || al == VT_I4 || al == VT_UI4)
                lea     edx, [esi+8]
                .if(ah)
                    mov edx, [edx]
                .endif
                .if(al == VT_I1)
                    movsx   edx, BYTE PTR [edx]
                .elseif(al == VT_UI1)
                    movzx   edx, BYTE PTR [edx]
                .elseif(al == VT_I2)
                    movsx   edx, WORD PTR [edx]
                .elseif(al == VT_UI2)
                    movzx   edx, WORD PTR [edx]
                .else
                    mov     edx, [edx]
                .endif
                invoke  sqlite3_bind_int, lStatement, ecx, edx
            .elseif(al == VT_I8 || al == VT_UI8)
                lea     edx, [esi+8]
                .if(ah)
                    mov edx, [edx]
                .endif
                
                push    [edx+4]
                push    [edx+0]
                push    ecx
                push    lStatement
                call    sqlite3_bind_int64
                ;invoke  sqlite3_bind_int64, lStatement, ecx, [edx+0]:[edx+4]
            .elseif(al == VT_R4)
                lea     edx, [esi+8]
                .if(ah)
                    mov edx, [edx]
                .endif
                
                fld     DWORD PTR [edx]
                push    0
                push    0
                fstp    QWORD PTR [esp]
                push    ecx
                push    lStatement
                call    sqlite3_bind_double
            .elseif(al == VT_R8)
                lea     edx, [esi+8]
                .if(ah)
                    mov edx, [edx]
                .endif
                
                push    [edx+4]
                push    [edx+0]
                push    ecx
                push    lStatement
                call    sqlite3_bind_double
            .elseif(al == VT_BSTR)
                mov     edx, [esi+8]
                .if(ah)
                    mov edx, [edx]
                .endif      ; use bind_text16 because VB passes strings as UNICODE
                .if(edx == 0)
                    invoke  sqlite3_bind_null, lStatement, ecx
                .else
                    invoke  sqlite3_bind_text16, lStatement, ecx, edx, DWORD PTR [edx-4], SQLITE_TRANSIENT
                .endif
            .else
                mov eax, HRESULT_INVALID_TYPE
                add esp, 8
                jmp Error
            .endif
            pop     esi
            pop     ecx
            add     esi, [edi].cbElements
            .if(eax && eax != SQLITE_RANGE)
                or  eax, HRESULT_SQLITE
                jmp Error
            .endif
        .endw
    .endif
    
Error:
    invoke  SafeArrayUnaccessData, edi
    ASSUME edi:NOTHING
@Error:
    ret
SetParameters ENDP

; 

ExecuteStep PROC lStatement:DWORD
    invoke  sqlite3_step, lStatement
    .if(eax == SQLITE_ERROR)
        invoke  sqlite3_reset, lStatement
    .endif
    
    .if(eax && eax != SQLITE_DONE)
        or  eax, HRESULT_SQLITE
    .else
        xor eax, eax
    .endif
    ret
ExecuteStep ENDP

; 

SelectStep PROC USES esi edi ebx lStatement:DWORD, pStruct:DWORD
    LOCAL   saBound:SAFEARRAYBOUND
    
    mov     saBound.lLbound, 0
    mov     edi, pStruct
    ASSUME  edi:PTR SQLITEVBRow
    
    invoke  sqlite3_step, lStatement
    .if(eax == SQLITE_BUSY)
        mov     esi, 5      ; 5 attempts before throwing an error
        .while(esi && eax == SQLITE_BUSY)
            invoke  Sleep, 1000
            invoke  sqlite3_step, lStatement
            dec     esi
        .endw
        .if(eax == SQLITE_BUSY)
            or      eax, HRESULT_SQLITE
            jmp     Abort
        .endif
    .endif
    .if(eax == SQLITE_DONE || eax == SQLITE_MISUSE)
        mov     [edi].dwCols, 0
        mov     [edi].bValid, 0
        mov     [edi].saRow, 0
        jmp     Abort
    .endif
    .if(eax == SQLITE_ERROR)
        invoke  sqlite3_reset, lStatement
        or      eax, HRESULT_SQLITE
        jmp     Abort
    .endif
    ; if we made it this far we've got SQLITE_ROW
    invoke  sqlite3_column_count, lStatement
    mov     [edi].dwCols, eax
    mov     [edi].bValid, -1
    mov     saBound.cElements, eax
    invoke  SafeArrayCreate, VT_VARIANT, 1, ADDR saBound
    mov     [edi].saRow, eax
    push    0
    invoke  SafeArrayAccessData, eax, esp
    pop     esi
    xor     ebx, ebx
    .while(ebx < [edi].dwCols)
        invoke  sqlite3_column_decltype, lStatement, ebx
        .if(eax)
            mov     eax, [eax]
            bswap   eax
            .if(eax == 'INTE')                      ; INTEGER
                mov eax, VT_I4
            .elseif(eax == 'FLOA' || eax == 'REAL') ; FLOAT or REAL
                mov eax, VT_R8
            .elseif(eax == 'TEXT' || eax == 'STRI') ; TEXT or STRING
                mov eax, VT_BSTR
            .elseif(eax == 'BLOB')                  ; BLOB
                mov eax, VT_ARRAY or VT_UI1
            .else
                mov eax, VT_EMPTY
            .endif
        .else
            invoke  sqlite3_column_type, lStatement, ebx
            .if(eax == SQLITE_INTEGER)
                mov eax, VT_I4
            .elseif(eax == SQLITE_FLOAT)
                mov eax, VT_R8
            .elseif(eax == SQLITE_TEXT)
                mov eax, VT_BSTR
            .elseif(eax == SQLITE_BLOB)
                mov eax, VT_ARRAY or VT_UI1
            .else
                mov eax, VT_EMPTY
            .endif
        .endif
        
        push    eax
        invoke  VariantInit, esi
        pop     eax
        mov     [esi], eax
        add     esi, 8
        .if(eax == VT_I4)
            invoke  sqlite3_column_int, lStatement, ebx
            mov     [esi], eax
        .elseif(eax == VT_R8)
            invoke  sqlite3_column_double, lStatement, ebx
            fstp    QWORD PTR [esi]
        .elseif(eax == VT_BSTR)
            invoke  sqlite3_column_text16, lStatement, ebx
            ;invoke  SysAllocUniStringByte, eax
            invoke  SysAllocString, eax
            mov     [esi], eax
        .elseif(eax == (VT_ARRAY or VT_UI1))
            invoke  sqlite3_column_bytes, lStatement, ebx
            mov     saBound.cElements, eax
            invoke  SafeArrayCreate, VT_UI1, 1, ADDR saBound
            mov     [esi], eax
            push    esi
            push    eax
            push    esi
            invoke  SafeArrayAccessData, eax, esp
            pop     esi
            invoke  sqlite3_column_blob, lStatement, ebx
            .while(saBound.cElements)
                mov cl, [eax]
                mov [esi], cl
                inc eax
                inc esi
                dec saBound.cElements
            .endw
            pop     eax
            pop     esi
            invoke  SafeArrayUnaccessData, eax
        .elseif(eax == VT_EMPTY)
        .endif
        
        add     esi, 8
        
        inc     ebx
    .endw
    
    invoke  SafeArrayUnaccessData, [edi].saRow
Abort:
    ASSUME  edi:NOTHING
    ret
SelectStep ENDP

; 

END
