; NOMAKEIT NOLINK !CLEAN
; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
; 

include sqlitevb.inc

; 
    .const
        sNameFormat         BYTE    "%S_%S__%S_%S", 0
        sInsertTrigger      BYTE    "CREATE TRIGGER fki_%S BEFORE INSERT ON %S "
                            BYTE    "FOR EACH ROW BEGIN "
                            BYTE        "SELECT RAISE(ABORT,'foreign key constraint') "
                            BYTE        "WHERE (SELECT %S FROM %S WHERE %S = NEW.%S) IS NULL;"
                            BYTE    "END;", 0

        sUpdateTrigger      BYTE    "CREATE TRIGGER fku_%S BEFORE UPDATE ON %S "
                            BYTE    "FOR EACH ROW BEGIN "
                            BYTE        "SELECT RAISE(ABORT,'foreign key constraint') "
                            BYTE        "WHERE NEW.%S IS NOT NULL "
                            BYTE        "AND (SELECT %S FROM %S WHERE %S = NEW.%S) IS NULL;"
                            BYTE    "END;", 0

        sDeleteTrigger      BYTE    "CREATE TRIGGER fkd_%S BEFORE DELETE ON %S "
                            BYTE    "FOR EACH ROW BEGIN "
                            BYTE        "SELECT RAISE(ABORT,'foreign key constraint') "
                            BYTE        "WHERE (SELECT %S FROM %S WHERE %S = OLD.%S) IS NOT NULL;"
                            BYTE    "END;", 0
        
        sDropTrigger        BYTE    "DROP TRIGGER %S_%S", 0

        spNameFormat        TEXTEQU <OFFSET sNameFormat>
        spInsertTrigger     TEXTEQU <OFFSET sInsertTrigger>
        spUpdateTrigger     TEXTEQU <OFFSET sUpdateTrigger>
        spDeleteTrigger     TEXTEQU <OFFSET sDeleteTrigger>
        spDropTrigger       TEXTEQU <OFFSET sDropTrigger>
        
; 
    .code
; 

CreateReference PROC lDB:DWORD, spForeignKeyTable:DWORD, spForeignKey:DWORD, spPrimaryKeyTable:DWORD, spPrimaryKey:DWORD
    LOCAL   dwSuccess:DWORD
    LOCAL   spName:DWORD
    
;    OnErrorReturn HRESULT_NULL_PTR
    
    mov     dwSuccess, 0
    Format  spNameFormat, spForeignKeyTable, spForeignKey, spPrimaryKeyTable, spPrimaryKey
    mov     spName, eax
    or      eax, eax
    jz      Abort
    
    mov     dwSuccess, 7
    Format  spInsertTrigger, spName, spForeignKeyTable, spPrimaryKey, spPrimaryKeyTable, spPrimaryKey, spForeignKey
    push    eax
    invoke  sqlite3_exec, lDB, eax, 0, 0, 0
    .if(eax)
        xor dwSuccess, 1
    .endif
    pop     eax
    StringFree eax
    
    Format  spUpdateTrigger, spName, spForeignKeyTable, spForeignKey, spPrimaryKey, spPrimaryKeyTable, spPrimaryKey, spForeignKey
    push    eax
    invoke  sqlite3_exec, lDB, eax, 0, 0, 0
    .if(eax)
        xor dwSuccess, 2
    .endif
    pop     eax
    StringFree eax

    Format  spDeleteTrigger, spName, spPrimaryKeyTable, spForeignKey, spForeignKeyTable, spForeignKey, spPrimaryKey
    push    eax
    invoke  sqlite3_exec, lDB, eax, 0, 0, 0
    .if(eax)
        xor dwSuccess, 4
    .endif
    pop     eax
    StringFree eax
    
    StringFree spName
    
Abort:
    .if(eax)
        xor eax, eax
    .else
        mov eax, HRESULT_SQLITE or SQLITE_ERROR
    .endif
    ret
CreateReference ENDP

; 

DeleteReference PROC lDB:DWORD, spForeignKeyTable:DWORD, spForeignKey:DWORD, spPrimaryKeyTable:DWORD, spPrimaryKey:DWORD
    LOCAL   dwSuccess:DWORD
    LOCAL   spName:DWORD
    LOCAL   sTemp:DWORD
    
;    OnErrorReturn HRESULT_NULL_PTR
    
    mov     dwSuccess, 0
    Format  spNameFormat, spForeignKeyTable, spForeignKey, spPrimaryKeyTable, spPrimaryKey
    mov     spName, eax
    or      eax, eax
    jz      Abort2
    
    
    mov     dwSuccess, 7
    
    mov     sTemp, 'ikf'        ; = "fki"
    Format  spDropTrigger, ADDR sTemp, spName
    push    eax
    invoke  sqlite3_exec, lDB, eax, 0, 0, 0
    .if(eax)
        xor dwSuccess, 1
    .endif
    pop     eax
    StringFree eax
    
    mov     sTemp, 'ukf'        ; = "fku"
    Format  spDropTrigger, ADDR sTemp, spName
    push    eax
    invoke  sqlite3_exec, lDB, eax, 0, 0, 0
    .if(eax)
        xor dwSuccess, 2
    .endif
    pop     eax
    StringFree eax

    mov     sTemp, 'dkf'        ; = "fkd"
    Format  spDropTrigger, ADDR sTemp, spName
    push    eax
    invoke  sqlite3_exec, lDB, eax, 0, 0, 0
    .if(eax)
        xor dwSuccess, 4
    .endif
    pop     eax
    StringFree eax
    
Abort2:
    .if(eax)
        xor eax, eax
    .else
        mov eax, HRESULT_SQLITE or SQLITE_ERROR
    .endif
    ret
DeleteReference ENDP

; 

END
