    include \masm32\include\windows.inc
    
    ASMRT_NO_MODEL = 1
    ASMRT_NO_ENTRY = 1
    ASMRT_NO_ERROR = 1
    include     ASMRT.inc
    includelib  ASMRT.lib
    
    
    include     Oleaut32.inc
    
    includelib  Oleaut32.lib
    includelib  \pellesc\lib\win\kernel32.lib
    includelib  \pellesc\lib\crt.lib
    
    include     sqlite3.3.5.inc
    
; 
; error codes

HRESULT_SUCCESS     EQU     000000000h
HRESULT_ERROR       EQU     080048000h
HRESULT_SQLITE      EQU     080048100h

HRESULT_NO_BEGIN    EQU     1 or HRESULT_ERROR
HRESULT_NULL_PTR    EQU     2 or HRESULT_ERROR
HRESULT_BAD_LOCK    EQU     3 or HRESULT_ERROR
HRESULT_CANNOT_RET  EQU     4 or HRESULT_ERROR
HRESULT_INVALID_TYPE EQU    5 or HRESULT_ERROR

; 
; prototypes

OpenDB			PROTO sFilename:DWORD, lpDB:DWORD
CloseDB			PROTO lDB:DWORD

;Select			PROTO pStruct:DWORD, lDB:DWORD, sStatement:DWORD
InsertInto			PROTO spTable:DWORD, spColumns:DWORD, saValues:DWORD
Update                  PROTO spTable:DWORD, spWhereClause:DWORD, spColumns:DWORD, saValues:DWORD
Delete                  PROTO spTable:DWORD, spWhereClause:DWORD

SingleInsertInto		PROTO lDB:DWORD, spTable:DWORD, spColumns:DWORD, saValues:DWORD
SingleUpdate		PROTO lDB:DWORD, spTable:DWORD, spWhereClause:DWORD, spColumns:DWORD, saValues:DWORD
SingleDelete		PROTO lDB:DWORD, spTable:DWORD, spWhereClause:DWORD

Begin				PROTO lDB:DWORD
Commit			PROTO
Rollback			PROTO
Execute			PROTO sStatement:DWORD

PrepareStatement		PROTO lDB:DWORD, sStatement:DWORD, lpStatement:DWORD
CloseStatement		PROTO lStatement:DWORD
SetParameters		PROTO lStatement:DWORD, saParams:DWORD
SelectStep			PROTO lStatement:DWORD, pStruct:DWORD
ExecuteStep			PROTO lStatement:DWORD

SysAllocStringByte	PROTO sz:DWORD
SysAllocUniStringByte	PROTO sz:DWORD

; 
; structures

SAFEARRAYBOUND STRUCT
    cElements   DWORD   ?
    lLbound     DWORD   ?
SAFEARRAYBOUND ENDS

SAFEARRAY STRUCT
    cDims       WORD    ?
    fFeatures   WORD    ?
    cbElements  DWORD   ?
    cLocks      DWORD   ?
    pvData      DWORD   ?
    rgsabound   SAFEARRAYBOUND  <?>
SAFEARRAY ENDS

;SQLITEVBTable STRUCT
;    dwCols      DWORD   ?   ; -1 on error
;    dwRows      DWORD   ?   ; error value on error
;    saColName   DWORD   ?
;    saRow       DWORD   ?   ; error text
;SQLITEVBTable ENDS

SQLITEVBRow STRUCT
    bValid      DWORD   ?
    dwCols      DWORD   ?   ; 0 on success, -1 on error, col count on data
    saRow       DWORD   ?
SQLITEVBRow ENDS

; 
; macros

InternalPrepareStatement MACRO db:REQ, spStatement:REQ
    push    0
    mov     eax, esp
    invoke  sqlite3_prepare16, db, spStatement, -1, eax, 0
    mov     ecx, eax
    .if(eax)
        mov DWORD PTR [esp], 0
    .endif
    pop     eax
ENDM

repmovswb MACRO
    .while(ecx)
        mov al, [esi]
        mov [edi], al
        add esi, 2
        inc edi
        sub ecx, 2
    .endw
ENDM

repmovsbw MACRO
    mov ah, 0
    .while(ecx)
        mov al, [esi]
        mov [edi], ax
        inc esi
        add edi, 2
        dec ecx
    .endw
ENDM
